
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Varnish - 10 going on 50 &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Brinch-Hansens Arrows" href="brinch-hansens-arrows.html" />
    <link rel="prev" title="The first design of Varnish" href="firstdesign.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="brinch-hansens-arrows.html" title="Brinch-Hansens Arrows"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="firstdesign.html" title="The first design of Varnish"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Varnish - 10 going on 50</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="varnish-10-going-on-50">
<span id="phk-10goingon50"></span><h1>Varnish - 10 going on 50<a class="headerlink" href="#varnish-10-going-on-50" title="Permalink to this headline">¶</a></h1>
<p>Ten years ago, Dag-Erling and I were busy hashing out the big lines
of Varnish.</p>
<p>Hashing out had started on a blackboard at University of Basel
during the <a class="reference external" href="http://2005.eurobsdcon.org/">EuroBSDcon 2005</a> conference,
and had continued in email and IRC ever since.</p>
<p>At some point in February 2006 Dag-Erling laid down the foundations of
our Subversion and source tree.</p>
<p>The earliest fragment which have survived the conversion to Git is
subversion commit number 9:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">commit</span> <span class="mi">523166</span><span class="n">ad2dd3a65e3987f13bc54f571f98453976</span>
<span class="n">Author</span><span class="p">:</span> <span class="n">Dag</span> <span class="n">Erling</span> <span class="n">Smørgrav</span> <span class="o">&lt;</span><span class="n">des</span><span class="nd">@des</span><span class="o">.</span><span class="n">no</span><span class="o">&gt;</span>
<span class="n">Date</span><span class="p">:</span>   <span class="n">Wed</span> <span class="n">Feb</span> <span class="mi">22</span> <span class="mi">14</span><span class="p">:</span><span class="mi">31</span><span class="p">:</span><span class="mi">39</span> <span class="mi">2006</span> <span class="o">+</span><span class="mi">0000</span>

    <span class="n">Additional</span> <span class="n">subdivisions</span><span class="o">.</span>
</pre></div>
</div>
<p>We consider this the official birth-certificate of the Varnish Cache
FOSS project, and therefore we will celebrate the 10 year birthday
of Varnish in a couple of weeks.</p>
<p>We’re not sure exactly how and where we will celebrate this, but
follow Twitter user <a class="reference external" href="https://twitter.com/varnishcache">&#64;varnishcache</a>
if you want don’t want to miss the partying.</p>
<section id="vclocc1">
<h2>VCLOCC1<a class="headerlink" href="#vclocc1" title="Permalink to this headline">¶</a></h2>
<p>One part of the celebration, somehow, sometime, will be the “VCL
Obfuscated Code Contest #1” in the same spirit as the <a class="reference external" href="http://www.ioccc.org/">International
Obfuscated C Code Contest</a>.</p>
<p>True aficionados of Obfuscated Code will also appreciate this
amazing <a class="reference external" href="http://www.multicians.org/proc-proc.html">Obfuscated PL/1</a>.</p>
<p>The official VCLOCC1 contest rules are simple:</p>
<ul class="simple">
<li><p>VCL code must work with Varnish 4.1.1</p></li>
<li><p>As many Varnishd instances as you’d like.</p></li>
<li><p>No inline-C allowed</p></li>
<li><p>Any VMOD you want is OK</p></li>
<li><p>You get to choose the request(s) to send to Varnishd</p></li>
<li><p>If you need backends, they must be simulated by varnishd (4.1.1) instances.</p></li>
<li><p><em>We</em> get to publish the winning entry on the Varnish project home-page.</p></li>
</ul>
<p>The <em>only</em> thing which counts is the amazing/funny/brilliant
VCL code <em>you</em> write and what it does.  VMODs and backends are just
scaffolding which the judges will ignore.</p>
<p>We will announce the submission deadline one month ahead of time, but
you are more than welcome to start already now.</p>
</section>
<section id="releases">
<h2>Releases<a class="headerlink" href="#releases" title="Permalink to this headline">¶</a></h2>
<p>Our 10 year anniversary was a good excuse to take stock and look at
the way we work, and changes are and will be happening.</p>
<p>Like any respectable FOSS project, the Varnish project has never been
accused, or guilty, of releasing on the promised date.</p>
<p>Not even close.</p>
<p>With 4.1 not even close to close.</p>
<p>Having been around that block a couple of times, (<em>cough</em> FreeBSD 5.0 <em>cough</em>)
I think I know why and I have decided to put a stop to it.</p>
<p>Come hell or high water <a class="footnote-reference brackets" href="#f1" id="id1">1</a>, Varnish 5.0 will be released September
15th 2016.</p>
<p>And the next big release, whatever we call it, will be middle of
March 2017, and until we change our mind, you can trust a major
release of Varnish to happen every six months.</p>
<p>Minor releases, typically bugfixes, will be released as need arise,
and these should just be installable with no configuration changes.</p>
<p>Sounds wonderful, doesn’t it ?  Now you can plan your upgrades.</p>
<p>But nothing comes free:  Until we are near September, we won’t be able
to tell you what Varnish 5 contains.</p>
<p>We have plans and ideas for what <em>should</em> be there, and we will work
to reach those milestones, but we will not hold the release for “just this
one more feature” if they are not ready.</p>
<p>If it is in on September 15th, it will be in the release, if not, it wont.</p>
<p>And since the next release is guaranteed to come six months later,
it’s not a catastrophe to miss the deadline.</p>
<p>So what’s the problem and why is this draconian solution better ?</p>
<p>Usually, when FOSS projects start, they are started by “devops”,
Varnish certainly did:  Dag-Erling ran a couple of sites
with Varnish, as did Kristian, and obviously Anders and Audun of
VG did as well, so finding out if you improved or broke things
during development didn’t take long.</p>
<p>But as a project grows, people gravitate from “devops” to “dev”,
and suddenly we have to ask somebody else to “please test -trunk”
and these people have their own calendars, and are not sure why
they should test, or even if they should test, much less what they
should be looking for while they test, because they have not been
part of the development process.</p>
<p>In all honesty, going from Varnish1 to Varnish4 the amount of
real-life testing our releases have received <em>before</em> being released
has consistently dropped <a class="footnote-reference brackets" href="#f2" id="id2">2</a>.</p>
<p>So we’re moving the testing on the other side of the release date,
because the people who <em>can</em> live-test Varnish prefer to have a
release to test.</p>
<p>We’ll run all the tests we can in our development environments and
we’ll beg and cajole people with real sites into testing also, but
we won’t wait for weeks and months for it to happen, like we did
with the 4.1 release.</p>
<p>All this obviously changes the dynamics of the project, and it we
find out it is a disaster, we’ll change our mind.</p>
<p>But until then:  Two major releases a year, as clock-work, mid-September
and mid-March.</p>
</section>
<section id="moving-to-github">
<h2>Moving to github<a class="headerlink" href="#moving-to-github" title="Permalink to this headline">¶</a></h2>
<p>We’re also moving the project to github.  We’re trying to find out
a good way to preserve the old Trac contents, and once we’ve
figured that out, we’ll pull the handle on the transition.</p>
<p>Trac is starting to creak in the joints and in particular we’re
sick and tired of defending it against spammers.  Moving to github
makes that Somebody Elses Problem.</p>
<p>We also want to overhaul the project home-page and try to get
a/the wiki working better.</p>
<p>We’ll keep you posted about all this when and as it happens.</p>
</section>
<section id="we-were-hip-before-it-was-hip-to-be-hipsters">
<h2>We were hip before it was hip to be hipsters<a class="headerlink" href="#we-were-hip-before-it-was-hip-to-be-hipsters" title="Permalink to this headline">¶</a></h2>
<p>Moving to github also means moving into a different culture.</p>
<p>Githubs statistics are neat, but whenever you start to measure
something, it becomes a parameter for optimization and competition,
and there are people out there who compete on github statistics.</p>
<p>In one instance the “game” is simply to submit changes, no matter
how trivial, to as many different projects as you can manage in
order to claim that you “contribute to a lot of FOSS projects”.</p>
<p>There is a similar culture of “trophy hunting” amongst so-called
“security-researchers” - who has most CVE’s to their name?  It
doesn’t seem to matter to them how vacuous the charge or how
theoretical the “vulnerability” is, a CVE is a CVE to them.</p>
<p>I don’t want to play that game.</p>
<p>If you are a contributor to Varnish, you should already have the
nice blue T-shirt and the mug to prove it.  (Thanks Varnish-Software!)</p>
<p>If you merely stumble over a spelling mistake, you merely
stumbled over a spelling mistake, and we will happily
correct it, and put your name in the commit message.</p>
<p>But it takes a lot more that fixing a spelling mistake to
become recognized as “a Varnish contributor”.</p>
<p>Yeah, we’re old and boring.</p>
<p>Speaking of which…</p>
</section>
<section id="where-does-50-come-into-it">
<h2>Where does 50 come into it ?<a class="headerlink" href="#where-does-50-come-into-it" title="Permalink to this headline">¶</a></h2>
<p>On January 20th I celebrated my 50 year birthday, and this was a
much more serious affair than I had anticipated:  For the first
time in my life I have received a basket with wine and flowers on
my birthday.</p>
<p>I also received books and music from certain Varnish users,
much appreciated guys!</p>
<p>Despite numerically growing older I will insist, until the day I
die, that I’m a man of my best age.</p>
<p>That doesn’t mean I’m not changing.</p>
<p>To be honest, being middle-aged sucks.</p>
<p>Your body starts creaking and you get frustrated seeing people make
mistakes you warned them against.</p>
<p>But growing older also absolutely rulez, because your age allows
you to appreciate that you live in a fantastic future with a lot
of amazing changes - even if it will take a long time before
progress goes too far.</p>
<p>There does seem to be increasing tendency to want the kids off your
lawn, but I think I can control that.</p>
<p>But if not I hereby give them permission to steal my apples and
yell back at me, because I’ve seen a lot of men, in particular in
the technical world, grow into bitter old men who preface every
utterance with “As <em>I</em> already said <em>MANY</em> years ago…”, totally
oblivious to how different the world has become, how wrong their
diagnosis is and how utterly useless their advice is.</p>
<p>I don’t want to end up like that.</p>
<p>From now on my basic assumption is that I’m an old ass who is part
of the problem, and that being part of the solution is something I
have to work hard for, rather than the other way around.</p>
<p>In my case, the two primary physiological symptoms of middle age is
that after 5-6 hours my eyes tire from focusing on the monitor and
that my mental context-switching for big contexts is slower than
it used to be.</p>
<p>A couple of years ago I started taking “eye-breaks” after lunch.
Get away from the screen, preferably outside where I could rest my
eyes on stuff further away than 40cm, then later in the day
come back and continue hacking.</p>
<p>Going forward, this pattern will become more pronounced.  The amount
of hours I work will be the same, but I will be splitting the workday
into two halves.</p>
<p>You can expect me to be at my keyboard morning (08-12-ish EU time)
and evening (20-24-ish EU time) but I may be doing other stuff,
away from the keyboard and screen, during the afternoon.</p>
<p>Starting this year I have also changed my calendar.</p>
<p>Rather than working on various projects and for various customers
in increments of half days, I’m lumping things together in bigger
units of days and weeks.</p>
<p>Anybody who knows anything about process scheduling can see that
this will increase throughput at the cost of latency.</p>
<p>The major latency impact is that one of the middle weeks of each
month I will not be doing Varnish.  On the other hand, all
the weeks I do work on Varnish will now be full weeks.</p>
<p>And with those small adjustments, the Varnish project and I are
ready to tackle the next ten years.</p>
<p>Let me conclude with a big THANK YOU! to all Contributors and Users
of Varnish, for making the first 10 years more amazing than I ever
thought FOSS development could be.</p>
<p>Much Appreciated!</p>
<p><em>phk</em></p>
<p class="rubric">Footnotes</p>
<dl class="footnote brackets">
<dt class="label" id="f1"><span class="brackets"><a class="fn-backref" href="#id1">1</a></span></dt>
<dd><p>I’ve always wondered about that expression.  Is the assumption that
if <em>both</em> hell <em>and</em> high water arrives at the same time they will cancel
out ?</p>
</dd>
<dt class="label" id="f2"><span class="brackets"><a class="fn-backref" href="#id2">2</a></span></dt>
<dd><p>I’ve seriously considered if I should start a porn-site, just to
test Varnish, but the WAF of that idea was well below zero.</p>
</dd>
</dl>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Varnish - 10 going on 50</a><ul>
<li><a class="reference internal" href="#vclocc1">VCLOCC1</a></li>
<li><a class="reference internal" href="#releases">Releases</a></li>
<li><a class="reference internal" href="#moving-to-github">Moving to github</a></li>
<li><a class="reference internal" href="#we-were-hip-before-it-was-hip-to-be-hipsters">We were hip before it was hip to be hipsters</a></li>
<li><a class="reference internal" href="#where-does-50-come-into-it">Where does 50 come into it ?</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="firstdesign.html"
                        title="previous chapter">The first design of Varnish</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="brinch-hansens-arrows.html"
                        title="next chapter">Brinch-Hansens Arrows</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/10goingon50.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="brinch-hansens-arrows.html" title="Brinch-Hansens Arrows"
             >next</a> |</li>
        <li class="right" >
          <a href="firstdesign.html" title="The first design of Varnish"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Varnish - 10 going on 50</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>